﻿using System.Collections;
using System.Collections.Generic;
using System.Threading.Tasks;
using UnityEngine;
using LeanCloud;
using LeanCloud.Core;
using System;

public class LeanCloudUnity : MonoBehaviour
{
    void Start() {
        AVClient.HttpLog(Debug.Log);

        //var appId = "Eohx7L4EMfe4xmairXeT7q1w-gzGzoHsz";
        //var appKey = "GSBSGpYH9FsRdCss8TGQed0F";
        //AVClient.Initialize(new AVClient.Configuration {
        //    ApplicationId = appId,
        //    ApplicationKey = appKey,
        //    ApiServer = new System.Uri("https://avoscloud.com")
        //});
    }

    void OnGUI() {
        if (GUI.Button(new Rect(10, 10, 200, 30), "Create")) {
            Call();   
        }
        if (GUI.Button(new Rect(10, 100, 200, 30), "Save")) {
            Save();
        }
    }

    async void Save() {
        AVClient.HttpLog(Debug.Log);
        var appId = "Eohx7L4EMfe4xmairXeT7q1w-gzGzoHsz";
        var appKey = "GSBSGpYH9FsRdCss8TGQed0F";
        AVClient.Initialize(new AVClient.Configuration {
            ApplicationId = appId,
            ApplicationKey = appKey,
            Region = AVClient.Configuration.AVRegion.Public_East_China,
            ApiServer = new Uri("https://avoscloud.com"),
            EngineServer = new Uri("https://avoscloud.com"),
        });

        var file = new AVFile("img.assetbundle", new byte[] { 1,1,2,3,5,8 });
        await file.SaveAsync(new ProgressListener());
        Debug.Log($"file id: {file.ObjectId}");
    }

    class ProgressListener : IProgress<AVUploadProgressEventArgs> {
        public void Report(AVUploadProgressEventArgs value) {
            Debug.Log($"progress: {value.Progress}");
        }
    }

    async void Call() {
        var appId = "GSIRUlB5taiAdvjI1jynXHu7-gzGzoHsz";
        var appKey = "zPc1Cs5CKAr2i0QGPxtHhOma";
        AVClient.Initialize(new AVClient.Configuration {
            ApplicationId = appId,
            ApplicationKey = appKey,
            ApiServer = new System.Uri("https://avoscloud.com"),
            EngineServer = new System.Uri("https://avoscloud.com"),
        });
        var res = await AVCloud.CallFunctionAsync<string>("version", new Dictionary<string, object> {
                { "v", "g1.3.0" }
            });
        Debug.Log(res);
    }

    async void CreateObject() {
        var go = new AVObject("GameObject") {
            ["name"] = "LeanCloud Unity"
        };
        await go.SaveAsync();
        Debug.Log($"{go.ObjectId} saved");
    }
}
